diff -ruN freeswan-1.5.orig/doc/pkix/ldap-ca.quickstart freeswan-1.5/doc/pkix/ldap-ca.quickstart
--- freeswan-1.5.orig/doc/pkix/ldap-ca.quickstart	Wed Dec 31 19:00:00 1969
+++ freeswan-1.5/doc/pkix/ldap-ca.quickstart	Thu Oct  5 07:05:59 2000
@@ -0,0 +1,169 @@
+
+Quick Instructions on how I set up my own LDAP CA.
+-- Luc Lanthier, 20001004
+
+1- openldap server for CA use:
+-----------------------------------------------------------------
+cd /usr/src
+tar xfvz openldap-stable-20000704.tgz 
+cd openldap-1.2.11
+./configure --enable-shared --with-gnu-ld --enable-ldapd 
+make depend
+make
+cd tests
+make
+cd ..
+make install
+-----------------------------------------------------------------
+
+
+2: Notes on LDIF files:
+-----------------------------------------------------------------
+
+Use your favorite editor and create an LDIF file that contains:
+            dn: dc=<MY-DOMAIN>, dc=<COM> 
+            objectclass: dcObject 
+            objectclass: organization 
+            o: <MY ORGANIZATION> 
+            dc: <MY-DOMAIN> 
+
+            dn: cn=Manager, dc=<MY-DOMAIN>, dc=<COM> 
+            objectclass: organizationalRole 
+            cn: Manager
+
+Now, you may run ldapadd(1) to insert these entries into your directory.
+            ldapadd -D "cn=Manager, dc=<MY-DOMAIN>, dc=<COM>" -W -f example.ldif
+
+
+Now we're ready to verify the added entries are in your directory. You 
+can use any LDAP client to do this, but our example uses the 
+ldapsearch(1) tool. Remember to replace dc=example,dc=com with the correct 
+values for your site:
+            ldapsearch -b 'dc=example,dc=com' '(objectclass=*)'
+
+-----------------------------------------------------------------
+
+3- How I created my own LDIF file
+-----------------------------------------------------------------
+----------- LDIF.sh:
+#!/bin/sh 
+parser="./parsecert.pl"
+
+cat <<EOM
+dn: dc=netwinder, dc=org
+objectclass: dcObject 
+objectclass: organization 
+o: Rebel.com
+dc: SoftEng
+
+dn: cn=Manager, dc=netwinder, dc=org
+objectclass: organizationalRole 
+cn: Manager
+
+dn: cn=CA, dc=netwinder, dc=org
+cn: CA
+objectclass: certificationAuthority
+EOM
+
+# the crl and the certs HAVE to be in DER format.
+openssl crl -in /var/lib/ssl/crl.pem -inform PEM -outform DER | \
+	ldif -b certificationrevocationlist 
+openssl x509 -in /var/lib/ssl/cacert.pem -inform PEM -outform DER | \
+	ldif -b cACertificate 
+cat <<EOM
+
+dn: cn=sticky, dc=netwinder, dc=org
+cn: sticky
+objectclass: hostRecord
+ipv4Address: 10.1.49.233
+EOM
+
+openssl x509 -in /var/lib/ssl/certs/01.pem -inform PEM -outform DER | \
+	ldif -b servercertificate 
+
+cat <<EOM
+dNSRecord: sticky.netwinder.org
+
+dn: cn=x86rack1, dc=netwinder, dc=org
+cn: x86rack1
+objectclass: hostRecord
+ipv4Address: 10.8.49.101
+EOM
+
+openssl x509 -in /var/lib/ssl/certs/02.pem -inform PEM -outform DER | \
+	ldif -b servercertificate 
+echo "dNSRecord: x86rack1.netwinder.org"
+-----------------------------------------------------------------
+
+
+4- Additional files to set up:
+
+----------- /usr/local/etc/openldap/slapd.oc-x509.conf 
+--------------------------------------
+objectclass hostRecord
+	requires
+		objectClass
+	allows
+		dNSRecord,
+		ipv4Address,
+		servercertificate
+--------------------------------------
+
+------------ /usr/local/etc/openldap/slapd.at-x509.conf 
+--------------------------------------
+attribute	servercertificate			bin
+--------------------------------------
+
+------------ /usr/local/etc/openldap/slapd.conf 
+--------------------------------------
+#
+# See slapd.conf(5) for details on configuration options.
+# This file should NOT be world readable.
+#
+include		/usr/local/etc/openldap/slapd.at.conf
+include		/usr/local/etc/openldap/slapd.oc.conf
+schemacheck	off
+#referral	ldap://root.openldap.org/
+
+pidfile		/usr/local/var/slapd.pid
+argsfile	/usr/local/var/slapd.args
+
+#################
+# x509
+include		/usr/local/etc/openldap/slapd.at-x509.conf
+include		/usr/local/etc/openldap/slapd.oc-x509.conf
+
+#######################################################################
+# ldbm database definitions
+#######################################################################
+
+database	ldbm
+suffix		"dc=netwinder, dc=org"
+#suffix		"o=My Organization Name, c=US"
+rootdn		"cn=Manager, dc=netwinder, dc=org"
+#rootdn		"cn=Manager, o=My Organization Name, c=US"
+# cleartext passwords, especially for the rootdn, should
+# be avoid.  See slapd.conf(5) for details.
+rootpw		ipsecsecret
+# database directory
+# this directory MUST exist prior to running slapd AND
+# should only be accessable by the slapd/tools  Mode 700 recommended.
+#directory	/usr/local/var/openldap-ldbm
+directory	/var/lib/ssl/ldap-ldbm
+
+index default pres,eq
+index objectClass,uid
+index cn,sn eq,sub,approx
+--------------------------------------
+-----------------------------------------------------------------
+
+
+
+5- How I regen'd my ldap DB:
+-----------------------------------------------------------------
+killall slapd
+rm -f /var/lib/ssl/ldap-ldbm/*
+sh LDIF.sh > LDIF
+/usr/local/libexec/slapd -s 1
+ldapadd -D "cn=Manager, dc=netwinder, dc=org" -W -f LDIF
+-----------------------------------------------------------------
diff -ruN freeswan-1.5.orig/doc/pkix/openssl-ca.quickstart freeswan-1.5/doc/pkix/openssl-ca.quickstart
--- freeswan-1.5.orig/doc/pkix/openssl-ca.quickstart	Wed Dec 31 19:00:00 1969
+++ freeswan-1.5/doc/pkix/openssl-ca.quickstart	Thu Oct  5 07:05:59 2000
@@ -0,0 +1,66 @@
+How I set up a CA on RedHat 6.2 and used it:
+
+1- install openssl...
+cd /usr/src/redhat/SRPMS
+scp root@10.8.49.101:/usr/src/redhat/SRPMS/openssl*.src.rpm .
+rpm --rebuild openssl-0.9.5a-1.src.rpm
+cd ../RPMS/i386/
+rpm -i openssl-*
+
+2- Setting up the openssl CA.
+cd /var/lib/ssl
+ln -s /etc etc
+vi /etc/openssl.cnf; # (see README.certificates section 4.1)
+vi ca.ext; # (see README.certificates section 4.2)
+openssl req -new -newkey rsa:1024 -keyout \
+	/var/lib/ssl/private/cakey.pem -out careq.pem
+openssl x509 -CAcreateserial -signkey private/cakey.pem -req \
+	-in careq.pem -out cacert.pem -days 2000 -extfile ca.ext
+touch index.txt
+echo "01" > serial
+openssl ca -gencrl -out crl.pem; # distribute/make available to all hosts.
+
+3- adding to hosts (presuming flat file format)
+scp crl.pem 10.1.49.233:/etc/ipsec
+scp cacert.pem 10.1.49.233:/etc/ipsec
+scp crl.pem 10.8.49.101:/etc/ipsec
+scp cacert.pem 10.8.49.101:/etc/ipsec
+
+4- Each client host -- generate certificate requests.
+cd /etc/ipsec
+# make sure the info entered for each client is DIFFERENT.
+openssl req -new -newkey rsa:1024 -nodes -keyout \
+	/etc/ipsec/`hostname`.key -out /etc/ipsec/`hostname`.req.pem
+ln -fs `hostname`.key privkey.pem
+ln -fs `hostname`.pem pubcert.pem; # will be created soon.
+chmod 400 `hostname`.key
+
+5- CA host -- Signing certificates 
+vi /etc/openssl.cnf; # (see README.certificates section 4.6)
+vi /usr/local/bin/signIPSEC; # (see README.certificates section 4.6)
+chmod 700 /usr/local/bin/signIPSEC
+# use: signIPSEC foo.mydomain.com 192.168.1.5 foo.req
+cd /var/lib/ssl/
+mkdir -p newcerts
+scp root@10.1.49.233:/etc/ipsec/*.req.pem .
+scp root@10.8.49.101:/etc/ipsec/*.req.pem .
+signIPSEC sticky.netwinder.org 10.1.49.233 sticky.req.pem
+scp newcerts/`cat serial.old`.pem root@10.1.49.233:/etc/ipsec/sticky.pem
+signIPSEC x86rack1.netwinder.org 10.8.49.101 x86rack1.req.pem
+scp newcerts/`cat serial.old`.pem root@10.8.49.101:/etc/ipsec/x86rack1.pem
+mv /var/lib/ssl/newcerts/* /var/lib/ssl/certs
+c_rehash /var/lib/ssl/certs
+
+6- CA host: prepping flat file for client hosts
+cd /var/lib/ssl
+for ii in certs/01.pem certs/02.pem cacert.pem crl.pem;
+do
+  cat $ii | \
+  perl -e '$printme = 0; while (<>) { if (/---BEGIN/) {$printme = 1;}; if ($printme) {print STDOUT $_;} }; print STDOUT "\n";' \
+  >> flatfile.txt
+done
+# flatfile is created. Send to Client hosts.
+scp flatfile.txt root@10.1.49.233:/etc/ipsec
+scp flatfile.txt root@10.8.49.101:/etc/ipsec
+
+
diff -ruN freeswan-1.5.orig/pluto/Makefile freeswan-1.5/pluto/Makefile
--- freeswan-1.5.orig/pluto/Makefile	Sat May 20 15:50:00 2000
+++ freeswan-1.5/pluto/Makefile	Thu Oct  5 07:18:12 2000
@@ -32,16 +32,39 @@
 LIBDESLITE=$(FREESWANLIBDIR)/libdes.a
 LIBGMP=$(FREESWANLIBDIR)/libgmp.a
 
+#OPENSSLROOT=/opt/ssl
+#OPENSSLINCLS=-I$(OPENSSLROOT)/include
+#OPENSSLLIBS=-L$(OPENSSLROOT)/lib -Wl,-rpath $(OPENSSLROOT)/lib -lcrypto
+#OPENSSLDEFS=-DOPENSSL
+
+OPENSSLROOT=/usr/lib
+OPENSSLINCLS=
+OPENSSLLIBS=-lcrypto
+OPENSSLDEFS=-DOPENSSL
+
+OPENSSLOBJS=openssl.o xmap.o xmap_file.o xmap_dir.o xmap_db.o xmap_ldap.o \
+            x_sobj.o
+ 
+LDAPROOT=/usr/local
+LDAPINCS=-I$(LDAPROOT)/include
+LDAPLIBS=-L$(LDAPROOT)/lib -lldap -llber -Wl,-rpath $(LDAPROOT)/lib
+LDAPDEFS=-DHAVE_LDAP
+ 
+DBROOT=/usr
+DBINCS=-I$(DBROOT)/include
+DBLIBS=-L$(DBROOT)/lib -ldb
+DBDEFS=-DHAVE_DB -DHAVE_DB185
+                   
 KLIPSD=../klips/src
 
 INSTALL=install
 
 # -O on Linux makes gcc coredump when compiling sha1.c
-CFLAGS = -g -Wall -W -Wmissing-prototypes -Wpointer-arith -Wbad-function-cast \
-	-Wcast-qual -Wmissing-declarations -Wwrite-strings -Wstrict-prototypes
+CFLAGS = -g -Wall -Wmissing-prototypes -Wpointer-arith -Wbad-function-cast \
+	-Wcast-qual -Wmissing-declarations -Wwrite-strings
 
 # where to find klips headers and FreeS/WAN headers
-HDRDIRS = -I$(KLIPSD) $(FREESWANINCLS)
+HDRDIRS = -I$(KLIPSD) $(FREESWANINCLS) $(OPENSSLINCLS) $(LDAPINCS) $(DBINCS) 
 
 # On non-LINUX systems, these one of these may be needed (see endian.h)
 # BYTE_ORDER = -DBIG_ENDIAN=4321 -DLITTLE_ENDIAN=1234 -DBYTE_ORDER=BIG_ENDIAN
@@ -74,22 +97,28 @@
 
 CPPFLAGS = $(HDRDIRS) $(BYTE_ORDER) \
 	-DPLUTO -DKLIPS -DDODGE_DH_MISSING_ZERO_BUG -DOLD_RESOLVER \
-	-DDEBUG -DGCC_LINT
+	-DDEBUG -DGCC_LINT $(OPENSSLDEFS) $(LDAPDEFS) $(DBDEFS)
 
 ALLFLAGS = $(CPPFLAGS) $(CFLAGS)
 
 # libefence is a free memory allocation debugger
 # Solaris 2 needs -lsocket -lnsl
-LIBSPLUTO = -lresolv # -lefence
+LIBSPLUTO = -lresolv $(OPENSSLLIBS) $(LDAPLIBS) $(DBLIBS) # -lefence
 
 LDFLAGS =
 
 # Solaris needs -lsocket -lnsl
 LIBSWHACK =
 
+LIBSD2H   = $(OPENSSLLIBS) $(DBLIBS)
+
 BINNAMEPLUTO = pluto
 BINNAMEWHACK = whack
 
+# Comment this out if you don't have Berkeley DB available, which,
+# if you're running Linux is a bit strange...
+BINNAMED2H   = dir2hash
+
 RM = /bin/rm
 RMFLAGS = -f
 
@@ -102,11 +131,11 @@
 	 pluto.8 ipsec.secrets.5
 
 DISTGCRYPT = \
-	gcryptfix.c gcryptfix.h \
-	dsa.c dsa.h \
-	elgamal.c elgamal.h \
-	primegen.c \
-	smallprime.c
+        gcryptfix.c gcryptfix.h \
+        g10_dsa.c g10_dsa.h \
+        elgamal.c elgamal.h \
+        primegen.c \
+        smallprime.c
 
 DISTSRC = \
 	connections.c connections.h \
@@ -140,19 +169,23 @@
 
 # start of support for DSS/DSA.  Not currently used.
 # OBJSGCRYPT =  gcryptfix.o dsa.o elgamal.o primegen.o smallprime.o
-OBJSGCRYPT =
+OBJSGCRYPT =  gcryptfix.o g10_dsa.o elgamal.o primegen.o smallprime.o
+
 
 OBJSPLUTO = connections.o constants.o cookie.o crypto.o defs.o log.o \
 	state.o main.o server.o timer.o id.o ipsec_doi.o kernel.o \
 	kernel_comm.o demux.o packet.o preshared.o dnskey.o rnd.o spdb.o \
-	sha1.o md5.o $(OBJSGCRYPT) $(LIBDESLITE) $(LIBGMP) $(FREESWANLIB)
+	sha1.o md5.o $(OBJSGCRYPT) $(LIBDESLITE) $(LIBGMP) $(FREESWANLIB) \
+	$(OPENSSLOBJS)
 
 OBJSWHACK = whack.o $(FREESWANLIB)
 
-all: $(BINNAMEPLUTO) $(BINNAMEWHACK)
+OBJSD2H = dir2hash.o
+
+all: $(BINNAMEPLUTO) $(BINNAMEWHACK) $(BINNAMED2H)
 
 install: all
-	$(INSTALL) $(BINNAMEPLUTO) $(BINNAMEWHACK) $(BINDIR)
+	$(INSTALL) $(BINNAMEPLUTO) $(BINNAMEWHACK) $(BINNAMED2H) $(BINDIR)
 	$(INSTALL) pluto.8 $(PMANDIR)/ipsec_pluto.8
 	../utils/manlink $(PMANDIR) ipsec_pluto.8
 	$(INSTALL) ipsec.secrets.5 $(FMANDIR)
@@ -164,6 +197,9 @@
 $(BINNAMEWHACK): $(OBJSWHACK)
 	$(CC) -o $(BINNAMEWHACK) $(OBJSWHACK) $(LIBSWHACK)
 
+$(BINNAMED2H): $(OBJSD2H)
+	$(CC) -o $(BINNAMED2H) $(OBJSD2H) $(LIBSD2H)
+
 distlist:
 	@echo $(DIST)
 
@@ -183,8 +219,10 @@
 realclean: clean
 
 clean:
-	$(RM) $(RMFLAGS) $(OBJSPLUTO) *.core core *~ a.out ktrace.out
-	$(RM) $(RMFLAGS) $(BINNAMEPLUTO) $(OBJSWHACK) $(BINNAMEWHACK)
+	$(RM) $(RMFLAGS) $(OBJSPLUTO) $(OBJSD2H) \
+		*.core core *~ a.out ktrace.out
+	$(RM) $(RMFLAGS) $(BINNAMEPLUTO) $(OBJSWHACK) $(BINNAMEWHACK) \
+		$(BINNAMED2H)
 
 .c.o:
 	$(CC) $(COPTS) $(ALLFLAGS) -c $<
@@ -222,9 +260,6 @@
 defs.o: defs.c
 demux.o: demux.c
 dnskey.o: dnskey.c
-dsa.o: dsa.c
-elgamal.o: elgamal.c
-gcryptfix.o: gcryptfix.c
 id.o: id.c
 ipsec_doi.o: ipsec_doi.c
 kernel.o: kernel.c
@@ -234,11 +269,9 @@
 md5.o: md5.c
 packet.o: packet.c
 preshared.o: preshared.c
-primegen.o: primegen.c
 rnd.o: rnd.c
 server.o: server.c
 sha1.o: sha1.c
-smallprime.o: smallprime.c
 spdb.o: spdb.c
 state.o: state.c
 timer.o: timer.c
@@ -298,23 +331,6 @@
 dnskey.o: preshared.h
 dnskey.o: dnskey.h
 dnskey.o: packet.h
-dsa.o: constants.h
-dsa.o: defs.h
-dsa.o: log.h
-dsa.o: rnd.h
-dsa.o: gcryptfix.h
-dsa.o: dsa.h
-elgamal.o: constants.h
-elgamal.o: defs.h
-elgamal.o: log.h
-elgamal.o: rnd.h
-elgamal.o: gcryptfix.h
-elgamal.o: elgamal.h
-gcryptfix.o: constants.h
-gcryptfix.o: defs.h
-gcryptfix.o: log.h
-gcryptfix.o: rnd.h
-gcryptfix.o: gcryptfix.h
 id.o: constants.h
 id.o: defs.h
 id.o: id.h
@@ -400,11 +416,6 @@
 preshared.o: state.h
 preshared.o: preshared.h
 preshared.o: log.h
-primegen.o: constants.h
-primegen.o: defs.h
-primegen.o: log.h
-primegen.o: rnd.h
-primegen.o: gcryptfix.h
 rnd.o: sha1.h
 rnd.o: constants.h
 rnd.o: defs.h
@@ -425,9 +436,6 @@
 server.o: kernel_comm.h
 sha1.o: sha1.h
 sha1.o: endian.h
-smallprime.o: constants.h
-smallprime.o: defs.h
-smallprime.o: gcryptfix.h
 spdb.o: constants.h
 spdb.o: defs.h
 spdb.o: id.h
diff -ruN freeswan-1.5.orig/pluto/connections.c freeswan-1.5/pluto/connections.c
--- freeswan-1.5.orig/pluto/connections.c	Wed Jun 21 14:24:31 2000
+++ freeswan-1.5/pluto/connections.c	Thu Oct  5 07:05:59 2000
@@ -39,6 +39,11 @@
 #include "preshared.h"
 #include "whack.h"
 
+#ifdef OPENSSL
+#include "openssl.h"
+#include "xmap.h"
+#endif
+
 static struct connection *connections = NULL;
 
 /* host_pair: a nexus of information about a pair of hosts.
@@ -242,6 +247,20 @@
     }
     unorient_connection(c);	/* won't delete c */
 
+#ifdef OPENSSL
+    {
+      int i;
+
+      for (i=0; i<MAX_OTHER; i++)
+	if (c->other[i].cert)
+	  X509_free((X509 *)(c->other[i].cert));
+    }
+
+    if (c->cert) X509_free((X509 *)(c->cert));
+    if (c->key) EVP_PKEY_free((EVP_PKEY *)(c->key));
+    if (c->lu) sk_XMAP_pop_free(c->lu, XMAP_free);
+#endif
+   
     /* find and delete c from connections list */
     list_rm(struct connection, next, c, connections);
     cur_connection = old_cur_connection;
@@ -444,7 +463,11 @@
 
 	for (; c != NULL; c = c->hp_next)
 	{
+#ifndef OPENSSL
 	    if ((c->policy ^ wm->policy) & (POLICY_PSK | POLICY_RSASIG))
+#else
+	    if ((c->policy ^ wm->policy) & (POLICY_PSK | POLICY_OPENSSL))
+#endif
 	    {
 		loglog(RC_CLASH
 		    , "authentication method disagrees with \"%s\", which is also for an unspecified peer"
@@ -499,6 +522,22 @@
 	    c->that = t;
 	}
 
+#ifdef OPENSSL
+	{
+		int i;
+
+		for(i=0; i<MAX_OTHER; i++) {
+			c->other[i].cert = NULL;
+			c->other[i].type = 0;
+		}
+	}
+	load_cert_and_key(wm->whack_certfile, wm->whack_keyfile,
+		(X509 **)&(c->cert), (EVP_PKEY **)&(c->key));
+	c->cert_options = parse_options(wm->whack_certopts);
+	make_lookups((STACK_OF(XMAP) **)(&(c->lu)), wm->whack_certpath);
+	strncpy(c->path, wm->whack_certpath, PATH_NAME_LIMIT);
+#endif
+
 	/* set internal fields */
 	c->next = connections;
 	connections = c;
@@ -806,7 +845,11 @@
 	    return NULL;	/* cannot determine PSK! */
 	break;
     case OAKLEY_RSA_SIG:
+#ifndef OPENSSL
 	auth_policy = POLICY_RSASIG;
+#else
+	auth_policy = POLICY_OPENSSL;
+#endif
 	my_RSA_pri = get_RSA_private_key(c);
 	if (my_RSA_pri == NULL)
 	    return NULL;	/* cannot determine my RSA private key! */
diff -ruN freeswan-1.5.orig/pluto/connections.h freeswan-1.5/pluto/connections.h
--- freeswan-1.5.orig/pluto/connections.h	Wed Jun 21 14:24:31 2000
+++ freeswan-1.5/pluto/connections.h	Thu Oct  5 07:05:59 2000
@@ -14,6 +14,10 @@
  * RCSID $Id: connections.h,v 1.38 2000/06/21 18:24:31 dhr Exp $
  */
 
+#ifdef OPENSSL
+#include "openssl_defs.h"
+#endif
+
 /* There are two kinds of connections:
  * - ISAKMP connections, between hosts (for IKE communication)
  * - IPsec connections, between clients (for secure IP communication)
@@ -78,6 +82,13 @@
  * the old one.  It is deleted when no longer in use.
  */
 
+#ifdef OPENSSL
+struct other_st {
+  u_int32_t type; /* type of certificate in 'cert': EVP_PKEY_RSA or EVP_PKEY_DSA */
+  void *cert;
+};
+#endif
+
 struct end {
     struct id id;
     struct in_addr	/* network order */
@@ -108,6 +119,18 @@
 
 struct connection {
     char *name;
+#ifdef OPENSSL
+    /* The declaration of these as void is truly horrific - they */
+    /* should be X509 and EVP_PKEY pointers. Unfortunately, if this */
+    /* is declared, the MD5 header files from OpenSSL conflict with those */
+    /* in the KLIPS source. Hence we cast these pointers to the right */
+    /* type at the time of use. It's disgusting, but I can't think of */
+    /* another way -- ND */
+    void *cert, *key, *lu;
+    struct other_st other[MAX_OTHER];
+    u_char path[PATH_NAME_LIMIT];
+    u_int32_t cert_options;
+#endif
     lset_t policy;
     time_t sa_ike_life_seconds;
     time_t sa_ipsec_life_seconds;
diff -ruN freeswan-1.5.orig/pluto/constants.c freeswan-1.5/pluto/constants.c
--- freeswan-1.5.orig/pluto/constants.c	Sun Jun 18 15:15:34 2000
+++ freeswan-1.5/pluto/constants.c	Thu Oct  5 07:05:59 2000
@@ -277,11 +277,37 @@
 enum_names ident_names =
     { ID_IPV4_ADDR, ID_KEY_ID, ident_name, NULL };
 
+#ifdef OPENSSL
+
+/* Certificate type values */
+static const char *const cert_name[] = {
+        "CERT_TYPE_NONE",
+	"CERT_TYPE_PKCS7",
+	"CERT_TYPE_PGP",
+	"CERT_TYPE_DNSKEY",
+	"CERT_TYPE_X509_SIG",
+	"CERT_TYPE_X509_KEX",
+	"CERT_TYPE_KERBEROS",
+	"CERT_TYPE_CRL",
+	"CERT_TYPE_ARL",
+	"CERT_TYPE_SPKI",
+	"CERT_TYPE_X509_ATTR",
+    };
+
+enum_names cert_names = 
+    { CERT_TYPE_NONE, CERT_TYPE_X509_ATTR, cert_name, NULL };
+
+#endif
+
 /* Goal BITs for establishing an SA */
 
 const char *const sa_policy_bit_names[] = {
 	"POLICY_PSK",
+#ifndef OPENSSL
 	"POLICY_RSASIG",
+#else
+	"POLICY_OPENSSL",
+#endif
 	"POLICY_ENCRYPT",
 	"POLICY_AUTHENTICATE",
 	"POLICY_TUNNEL",
diff -ruN freeswan-1.5.orig/pluto/constants.h freeswan-1.5/pluto/constants.h
--- freeswan-1.5.orig/pluto/constants.h	Tue Jun 20 16:09:45 2000
+++ freeswan-1.5/pluto/constants.h	Thu Oct  5 07:05:59 2000
@@ -433,17 +433,45 @@
 #define ID_DER_ASN1_GN              10
 #define ID_KEY_ID                   11
 
+#ifdef OPENSSL
+#define CERT_OPTION_SEND           0x01
+#define CERT_OPTION_PKCS7          0x02
+#define CERT_OPTION_PK             0x04
+#define CERT_OPTION_REV            0x08
+#define CERT_OPTION_STRICT         0x10
+#define CERT_OPTION_DSS_SHA        0x20
+#define CERT_OPTION_DSS_ALT        0x40
+
+extern enum_names cert_names;
+
+#define CERT_TYPE_NONE              0
+#define CERT_TYPE_PKCS7             1
+#define CERT_TYPE_PGP               2
+#define CERT_TYPE_DNSKEY            3
+#define CERT_TYPE_X509_SIG          4
+#define CERT_TYPE_X509_KEX          5
+#define CERT_TYPE_KERBEROS          6
+#define CERT_TYPE_CRL               7
+#define CERT_TYPE_ARL               8
+#define CERT_TYPE_SPKI              9
+#define CERT_TYPE_X509_ATTR        10
+#endif
+
 /* Policies for establishing an SA
  *
  * These are used to specify attributes (eg. encryption) and techniques for
- * (eg PFS) required of an SA.  POLICY_PSK and POLICY_RSASIG are for
+ * (eg PFS) required of an SA.  POLICY_PSK and POLICY_RSASIG/OPENSSL are for
  * ISAKMP SAs; the rest are about IPsec SAs
  */
 
 extern const char *const sa_policy_bit_names[];
 
 #define POLICY_PSK           LELEM(0)
+#ifndef OPENSSL
 #define POLICY_RSASIG        LELEM(1)
+#else
+#define POLICY_OPENSSL       LELEM(1)
+#endif
 
 #define POLICY_ENCRYPT       LELEM(2)
 #define POLICY_AUTHENTICATE  LELEM(3)
@@ -451,7 +479,11 @@
 #define POLICY_PFS           LELEM(5)
 
 #define POLICY_ISAKMP_SHIFT	0	/* log2(POLICY_PSK) */
+#ifndef OPENSSL
 #define POLICY_ISAKMP_MASK	(POLICY_PSK | POLICY_RSASIG)
+#else
+#define POLICY_ISAKMP_MASK  (POLICY_PSK | POLICY_OPENSSL)
+#endif
 #define POLICY_IPSEC_SHIFT	2	/* log2(POLICY_ENCRYPT) */
 
 /* Oakley transform attributes
diff -ruN freeswan-1.5.orig/pluto/crypto.h freeswan-1.5/pluto/crypto.h
--- freeswan-1.5.orig/pluto/crypto.h	Sun Dec 12 19:40:50 1999
+++ freeswan-1.5/pluto/crypto.h	Thu Oct  5 07:05:59 2000
@@ -56,7 +56,11 @@
 /* unification of cryptographic hashing mechanisms */
 
 union hash_ctx {
+#ifndef OPENSSL
 	MD5_CTX ctx_md5;
+#else
+	PLUTO_MD5_CTX ctx_md5;
+#endif
 	SHA1_CTX ctx_sha1;
     };
 
diff -ruN freeswan-1.5.orig/pluto/defs.c freeswan-1.5/pluto/defs.c
--- freeswan-1.5.orig/pluto/defs.c	Wed Jun 21 14:24:31 2000
+++ freeswan-1.5/pluto/defs.c	Thu Oct  5 07:05:59 2000
@@ -22,6 +22,8 @@
 #include "constants.h"
 #include "defs.h"
 #include "log.h"
+#include "id.h"
+#include "connections.h" /* needs id.h */
 #include "whack.h"	/* for RC_LOG_SERIOUS */
 
 const chunk_t empty_chunk = { NULL, 0 };
diff -ruN freeswan-1.5.orig/pluto/defs.h freeswan-1.5/pluto/defs.h
--- freeswan-1.5.orig/pluto/defs.h	Fri Feb 25 17:37:10 2000
+++ freeswan-1.5/pluto/defs.h	Thu Oct  5 07:05:59 2000
@@ -39,6 +39,22 @@
 typedef unsigned long so_serial_t;
 #define SOS_NOBODY  0	/* null serial number */
 
+#ifdef OPENSSL
+#include <des.h>
+
+typedef union _keysched_u {
+  struct _des3_ks { des_key_schedule ks[3]; } des3_ks;
+
+#if 0 /* *Please* don't define this - you *really* don't want single DES */
+  des_key_schedule des_ks;
+#endif
+
+#ifdef NOTYET
+  /* Other ciphers, eg CAST, RC5, etc... */
+#endif
+
+} keysched;
+#endif
 
 /* memory allocation */
 
